;simple 2 bitplane busdisplay example by tIn/newline.
;released at 10.07.2024 as part of the writeup to the "Ika I Compofylla" screen, released at Sommarhack 2024
;this works on all non-IMP MMUs (aka: the easy part)
            TEXT

            pea     0.w
            move.w  #$20,-(SP)
            trap    #1
            addq.w  #6,SP

            move    #$2700,SR
            clr.l   $fffffa06.w
            clr.l   $fffffa12.w
            move.b  #2,$ffff820a.w
            clr.b   $ffff8260.w

            move.l  #vbl,$70.w
            lea     stack,A7

            movem.w data+4(PC),D0-D3
            lea     $ffff8240.w,A0
            ;hide opcode/offset planes
            move.w  D0,(A0)+
            move.w  D1,(A0)+
            move.w  D2,(A0)+
            move.w  D3,(A0)+
            move.w  D0,(A0)+
            move.w  D1,(A0)+
            move.w  D2,(A0)+
            move.w  D3,(A0)+
            move.w  D0,(A0)+
            move.w  D1,(A0)+
            move.w  D2,(A0)+
            move.w  D3,(A0)+
            move.w  D0,(A0)+
            move.w  D1,(A0)+
            move.w  D2,(A0)+
            move.w  D3,(A0)+

            move.b  #%100,$ffff8001.w   ;2MB/0k (only do this if 4MB is detected)
            move.b  pscreendisplay+1,$ffff8201.w
            move.b  pscreendisplay+2,$ffff8203.w

            move    #$2300,sr
endless:    bra.s   endless

vbl:
            move.b  $ffff8209.w,D0
hardsync:   cmp.b   $ffff8209.w,D0
            beq.s   hardsync
            move.b  $ffff8209.w,D0
            not.w   D0
            lsr.w   D0,D0

            not.w   $ffff8240.w
            not.w   $ffff8240.w

            DCB.W   78,$4e71

            lea     data+128,A0
            move.w  #126-1,D7
scanline:
z SET 0
            REPT 20
            move.l  z(A0),D0    ;use this offset for your awesome effects
z SET z+4            
            ENDR
            lea     80(A0),A0
            not.w   $ffff8240.w
            not.w   $ffff8240.w
            DCB.W   35,$4e71
            dbra    d7,scanline

            rte
nope:       rte
data:       
            incbin  "logo.neo"  ;our awesome gfx data
            DS.L    10
stack:    
pal:        DS.W    16
pscreendisplay:
            DC.L    $2f0000
theend:
