;simple 2 plane busdisplay example by tIn/newline.
;released at 10.07.2024 as part of the writeup to the "Ika I Compofylla" screen, released at Sommarhack 2024
;this is a special case for IMP MMUs, just for the readers excercise
;we can't disable _just_ bank2 (aka the trivial case) on an IMP MMU, since both bank configs have to be equal. And since we this change bank1, too, we play it safe and just copy a stub 
;to lowmem and go from there - usually one would just copy an e.g. FDC-loader after switching to $8.w and then load the effect itself, since the old data >$400 gets trashed due to the 
;bank1 switch
ADDRESS EQU $8
            TEXT

            pea     0.w
            move.w  #$20,-(SP)
            trap    #1
            addq.w  #6,SP

            move    #$2700,sr
            clr.l   $fffffa06.w
            clr.l   $fffffa12.w
            move.b  #2,$ffff820a.w
            clr.b   $ffff8260.w

            lea     _start(PC),A0
            movem.l pal-start(A0),D0-D7
            movem.l D0-D7,$ffff8240.w

            lea     theend-start(A0),A1  
            lea     ADDRESS,A2
copy:            
            move.l  (A0)+,(A2)+
            cmp.l   A1,A0
            blt.s   copy
            jmp     ADDRESS
_start:
            ORG     ADDRESS

start:
            ;patch a hole for the VBL
            move.w  #$6004,$6e.w
            move.l  #looooop,$70.w
            lea     stack,A7

            move.b  #%101*01,$ffff8001.w ;512k/512k
            move.b  pscreendisplay+1,$ffff8201.w
            move.b  pscreendisplay+2,$ffff8203.w

            move    #$2300,sr

endless:    bra.s   endless

looooop:

            move.b  $ffff8209.w,D0
.hardsync:  cmp.b   $ffff8209.w,D0
            beq.s   .hardsync
            move.b  $ffff8209.w,D0
            not.w   D0
            lsr.w   D0,D0

            not.w   $ffff8240.w
            not.w   $ffff8240.w

            ;HEADS UP! here's a hole for $70  
            DCB.W   78,$4e71

            lea     data,A0
            move.w  #100-1,D7
scanline:
z SET 0
            REPT 20
            move.l  z(A0),D0    ;use this offset for your awesome effects
            ENDR
            not.b   $ffff8240.w
            not.b   $ffff8240.w
            DCB.W   512/4-20*(16/4)-11,$4e71
            dbra    d7,scanline

            rte
nope:       rte
data:       DC.L    $CCCCCCCC   ;our awesome gfx data
            DS.L    10
stack:    
pal:        DC.W    $001
            DC.W    $007
            DC.W    $070
            DC.W    $700
            DC.W    $001
            DC.W    $007
            DC.W    $070
            DC.W    $700
            DC.W    $001
            DC.W    $007
            DC.W    $070
            DC.W    $700
            DC.W    $001
            DC.W    $007
            DC.W    $070
            DC.W    $700

pscreendisplay:
            DC.L    $2f0000
theend:
